/** @file SkLogger.h
 SodaKit - Logging macros and methods
 
 Copyright (c) 2012 Edgemoor. All rights reserved.
 
 Licensed under the Apache License, Version 2.0 (the "License");
 you may not use this file except in compliance with the License.
 You may obtain a copy of the License at
 
 http://www.apache.org/licenses/LICENSE-2.0
 
 Unless required by applicable law or agreed to in writing, software
 distributed under the License is distributed on an "AS IS" BASIS,
 WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 See the License for the specific language governing permissions and
 limitations under the License.
 */

#ifndef SodaKit_SkLogger_h
#define SodaKit_SkLogger_h


#define SKLogMErr   RKLogError
#define SKLogMWrn   RKLogWarning
#define SKLogMInf   RKLogInfo
#define SKLogMDet   RKLogDebug

/**
 * The THIS_METHOD macro gives you the name of the current objective-c method.
 * 
 * Note: This does NOT work in straight C functions (non objective-c).
 * Instead you should use the predefined __FUNCTION__ macro.
 **/
#define SKLogM_THIS_METHOD NSStringFromSelector(_cmd)

void    SKLogArray(      NSArray*      array,      NSObject* title, NSInteger maxDepth );
void    SKLogDictionary( NSDictionary* dictionary, NSObject* title, NSInteger maxDepth );
void    SKLogError(      NSError*      error,      SEL       source,NSString* context );
void    SKLogException(  NSException*  exception,  SEL       source,NSString* context );

#endif
